"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClickToCopy = ClickToCopy;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const copy_to_clipboard_1 = __importDefault(require("copy-to-clipboard"));
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const react_2 = __importDefault(require("@tippyjs/react"));
/**
 * Renders an icon that you can click to copy some text.
 *
 * Relies on FontAwesome and `@tippyjs/react`.
 */
function ClickToCopy({ text, className }) {
    const [copied, setCopied] = (0, react_1.useState)(false);
    function copy() {
        (0, copy_to_clipboard_1.default)(text);
        setCopied(true);
    }
    (0, react_1.useEffect)(() => {
        if (!copied)
            return undefined;
        const timer = window.setTimeout(() => setCopied(false), 2000);
        return () => {
            window.clearTimeout(timer);
        };
    }, [copied]);
    const tooltip = copied ? 'Copied!' : 'Click to copy';
    const classes = ['click-to-copy'];
    if (className)
        classes.push(className);
    return ((0, jsx_runtime_1.jsx)(react_2.default, { content: tooltip, hideOnClick: false, children: (0, jsx_runtime_1.jsx)("div", { className: classes.join(' '), onClick: copy, onKeyDown: (e) => {
                if (e.key === 'Enter')
                    copy();
            }, role: "button", tabIndex: 0, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faCopy }) }) }));
}
