import React, { PropsWithChildren, ReactElement } from 'react';
/** The props type of [[`EasyFormPopoverWrapper`]]. */
export interface EasyFormPopoverManagerProps {
    renderReferenceElement(args: {
        setRef(element: HTMLElement | null): void;
        onClick(): void;
    }): ReactElement;
    popoverVisible: boolean;
    onPopoverVisibleChange(popoverVisible: boolean): void;
}
/**
 * Like [[`EasyFormDialog`]], but a popover. For small forms.
 *
 * There must be an empty `div` in the document with ID `easyFormPopoverPortalDestination`.
 */
export declare function EasyFormPopoverManager({ renderReferenceElement, children, popoverVisible, onPopoverVisibleChange, }: PropsWithChildren<EasyFormPopoverManagerProps>): React.ReactElement;
