"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormCheck = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importStar(require("react"));
const iti_react_core_1 = require("@interface-technologies/iti-react-core");
/**
 * An easy to use checkbox component.
 *
 * ```
 * <FormCheck
 *     checked={myBoolean}
 *     onChange={() => setMyBoolean(b => !b)}
 *     label="My checkbox"
 * />
 * ```
 *
 * `inline` is true by default and should be set to false if you want to display
 * a vertical stack of checkboxes.
 */
exports.FormCheck = react_1.default.memo(({ name, label, defaultChecked, checked, onChange, readOnly, className, autoComplete, tabIndex, enabled = true, inline = true, }) => {
    const idRef = (0, react_1.useRef)((0, iti_react_core_1.getGuid)());
    const classes = ['form-check'];
    if (inline)
        classes.push('form-check-inline');
    if (className)
        classes.push(className);
    return ((0, jsx_runtime_1.jsxs)("div", { className: classes.join(' '), children: [(0, jsx_runtime_1.jsx)("input", { type: "checkbox", className: "form-check-input", id: idRef.current, name: name, defaultChecked: defaultChecked, checked: checked, onChange: onChange, disabled: !enabled, readOnly: readOnly, autoComplete: autoComplete, tabIndex: tabIndex }), (0, jsx_runtime_1.jsx)("label", { className: "form-check-label user-select-none", htmlFor: idRef.current, children: label })] }));
});
