"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkButton = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
/**
 * A quick way to create an element that looks like a link but behaves
 * like a button.
 */
exports.LinkButton = react_1.default.forwardRef((props, ref) => {
    const { children, onClick, ...passThroughProps } = props;
    return ((0, jsx_runtime_1.jsx)("a", { ...passThroughProps, ref: ref, href: "#", onClick: (e) => {
            e.preventDefault();
            if (onClick)
                onClick(e);
        }, role: "button", children: children }));
});
