"use strict";
// Use this to allow the user to submit a form by pressing Ctrl+Enter
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCtrlEnterListener = useCtrlEnterListener;
const event_1 = __importDefault(require("@react-hook/event"));
// or Command+Enter on Mac
function useCtrlEnterListener(callback, enabled) {
    // keypress will not work
    (0, event_1.default)(window, 'keydown', (e) => {
        if (!enabled)
            return;
        if (e.ctrlKey && e.code === 'Enter') {
            callback();
        }
        else if (e.metaKey && e.code === 'Enter') {
            callback();
        }
    });
}
