"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidatedInput = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importStar(require("react"));
const iti_react_core_1 = require("@interface-technologies/iti-react-core");
const validation_1 = require("../validation");
exports.ValidatedInput = react_1.default.memo(({ id, type = 'text', autoComplete: _autoComplete = undefined, showValidation, className, enabled = true, name, ...otherProps }) => {
    var _a, _b;
    const { value, onChange: _onChange } = (0, iti_react_core_1.useControlledValue)({
        value: otherProps.value,
        onChange: otherProps.onChange,
        defaultValue: otherProps.defaultValue,
        fallbackValue: '',
    });
    const autoComplete = (0, react_1.useMemo)(() => _autoComplete, [_autoComplete]);
    function onChange(e) {
        _onChange(e.currentTarget.value);
    }
    const validatorOutput = (0, iti_react_core_1.useValidation)({
        value,
        name,
        onValidChange: otherProps.onValidChange,
        validators: otherProps.validators,
        validationKey: otherProps.validationKey,
        asyncValidator: otherProps.asyncValidator,
        onAsyncError: otherProps.onAsyncError,
        formLevelValidatorOutput: otherProps.formLevelValidatorOutput,
    });
    const inputClasses = [
        (0, validation_1.getValidationClass)(!validatorOutput, showValidation),
        'form-control',
    ];
    if ((_a = otherProps.inputAttributes) === null || _a === void 0 ? void 0 : _a.className)
        inputClasses.push(otherProps.inputAttributes.className);
    const inputAttributes = {
        ...otherProps.inputAttributes,
        disabled: !enabled,
        className: inputClasses.join(' '),
        autoComplete: autoComplete ? 'off' : (_b = otherProps.inputAttributes) === null || _b === void 0 ? void 0 : _b.autoComplete,
    };
    let input;
    /* -------------------------------------------------------------------- */
    const inputRef = (0, react_1.useRef)(null);
    const currentFocusRef = (0, react_1.useRef)(-1);
    const controllerRef = (0, react_1.useRef)(new AbortController());
    function scrollIntoViewIfNeeded(target) {
        if (target) {
            const parent = target.parentElement;
            if (parent &&
                target.getBoundingClientRect().bottom >
                    parent.getBoundingClientRect().bottom) {
                target.scrollIntoView({ block: 'nearest', inline: 'nearest' });
            }
            if (parent &&
                target.getBoundingClientRect().top <
                    parent.getBoundingClientRect().top) {
                target.scrollIntoView({ block: 'nearest', inline: 'nearest' });
            }
            if (target.getBoundingClientRect().bottom > window.innerHeight) {
                target.scrollIntoView({ block: 'nearest', inline: 'nearest' });
            }
            if (target.getBoundingClientRect().top < 0) {
                target.scrollIntoView({ block: 'nearest', inline: 'nearest' });
            }
        }
    }
    const removeActive = (0, react_1.useCallback)((els) => {
        /* a function to remove the "active" class from all autocomplete items: */
        for (let i = 0; i < els.length; i++) {
            els[i].classList.remove('autocomplete-active');
        }
    }, []);
    const addActive = (0, react_1.useCallback)((els) => {
        var _a;
        /* a function to classify an item as "active": */
        if (!els)
            return;
        /* start by removing the "active" class on all items: */
        removeActive(els);
        if (currentFocusRef.current >= els.length)
            currentFocusRef.current = 0;
        if (currentFocusRef.current < 0)
            currentFocusRef.current = els.length - 1;
        /* add class "autocomplete-active": */
        (_a = els[currentFocusRef.current]) === null || _a === void 0 ? void 0 : _a.classList.add('autocomplete-active');
        scrollIntoViewIfNeeded(els[currentFocusRef.current]);
    }, [removeActive]);
    const closeAllLists = (0, react_1.useCallback)((node, el) => {
        var _a;
        /* close all autocomplete lists in the document,
        except the one passed as an argument: */
        const x = document.getElementsByClassName('autocomplete-items');
        for (let i = 0; i < x.length; i++) {
            if (el !== x[i] && el !== node) {
                (_a = x[i].parentNode) === null || _a === void 0 ? void 0 : _a.removeChild(x[i]);
            }
        }
    }, []);
    function isInViewport(el) {
        if (!el)
            return false;
        const rect = el.getBoundingClientRect();
        return (rect.top >= 0 &&
            rect.left >= 0 &&
            rect.bottom <=
                (window.innerHeight || document.documentElement.clientHeight) &&
            rect.right <= (window.innerWidth || document.documentElement.clientWidth));
    }
    const setRef = (0, react_1.useCallback)((node) => {
        if (autoComplete) {
            if (inputRef.current) {
                // Make sure to cleanup any events/references added to the last instance
                controllerRef.current.abort();
            }
            if (node) {
                controllerRef.current = new AbortController();
                // Check if a node is actually passed. Otherwise node would be null.
                // You can now do what you need to, addEventListeners, measure, etc.
                node.addEventListener('input', function p() {
                    var _a;
                    let b;
                    let i;
                    const val = this.value;
                    /* close any already open lists of autocompleted values */
                    closeAllLists(node);
                    if (!val)
                        return;
                    currentFocusRef.current = -1;
                    /* create a DIV element that will contain the items (values): */
                    const a = document.createElement('DIV');
                    a.setAttribute('id', `${this.id}-autocomplete-list`);
                    a.setAttribute('class', 'autocomplete-items');
                    /* append the DIV element as a child of the autocomplete container: */
                    (_a = this.parentNode) === null || _a === void 0 ? void 0 : _a.appendChild(a);
                    /* for each item in the array... */
                    for (i = 0; i < autoComplete.length; i++) {
                        /* check if the item starts with the same letters as the text field value: */
                        if (autoComplete[i]
                            .substr(0, val.length)
                            .toUpperCase() === val.toUpperCase()) {
                            /* create a DIV element for each matching element: */
                            b = document.createElement('DIV');
                            /* make the matching letters bold: */
                            b.innerHTML = `<strong>${autoComplete[i].substr(0, val.length)}</strong>`;
                            b.innerHTML += autoComplete[i].substr(val.length);
                            /* insert a input field that will hold the current array item's value: */
                            b.innerHTML += `<input type='hidden' value='${autoComplete[i]}'>`;
                            /* execute a function when someone clicks on the item value (DIV element): */
                            b.addEventListener('click', function q() {
                                /* insert the value for the autocomplete text field: */
                                node.value =
                                    this.getElementsByTagName('input')[0].value;
                                _onChange(this.getElementsByTagName('input')[0]
                                    .value);
                                /* close the list of autocompleted values,
                        (or any other open lists of autocompleted values: */
                                closeAllLists(node);
                            });
                            a.appendChild(b);
                        }
                    }
                    if (!isInViewport(a)) {
                        a.setAttribute('class', 'autocomplete-items up');
                    }
                }, { signal: controllerRef.current.signal });
                /* execute a function presses a key on the keyboard: */
                node.addEventListener('keydown', function r(e) {
                    var _a;
                    const el = document.getElementById(`${this.id}-autocomplete-list`);
                    let els = [];
                    if (el)
                        els = [...el.getElementsByTagName('div')];
                    if (e.keyCode === 40) {
                        /* If the DOWN key is pressed and there are autocomplete matches, prevent the input cursor from moving, */
                        if (els.length > 0)
                            e.preventDefault();
                        /* If the arrow DOWN key is pressed,
                increase the currentFocus variable: */
                        currentFocusRef.current++;
                        /* and and make the current item more visible: */
                        addActive(els);
                    }
                    else if (e.keyCode === 38) {
                        /* If the UP key is pressed and there are autocomplete matches, prevent the input cursor from moving, */
                        if (els.length > 0)
                            e.preventDefault();
                        /* If the arrow UP key is pressed,
                decrease the currentFocus variable: */
                        currentFocusRef.current--;
                        /* and and make the current item more visible: */
                        addActive(els);
                    }
                    else if (e.keyCode === 13) {
                        /* If the ENTER key is pressed and there are autocomplete matches, prevent the form from being submitted, */
                        if (els.length > 0)
                            e.preventDefault();
                        if (currentFocusRef.current > -1) {
                            /* and simulate a click on the "active" item: */
                            if (els)
                                (_a = els[currentFocusRef.current]) === null || _a === void 0 ? void 0 : _a.click();
                        }
                    }
                }, { signal: controllerRef.current.signal });
            }
            // Save a reference to the node
            inputRef.current = node;
        }
    }, [autoComplete, addActive, closeAllLists, _onChange]);
    /* -------------------------------------------------------------------- */
    if (type && type.toLowerCase() === 'textarea') {
        input = ((0, jsx_runtime_1.jsx)("textarea", { id: id, name: name, value: value, onChange: onChange, ...inputAttributes }));
    }
    else if (autoComplete) {
        input = ((0, jsx_runtime_1.jsx)("div", { className: "autocomplete", children: (0, jsx_runtime_1.jsx)("input", { id: id, name: name, type: type, value: value, onChange: onChange, ref: setRef, ...inputAttributes }) }));
    }
    else {
        input = ((0, jsx_runtime_1.jsx)("input", { id: id, name: name, type: type, value: value, onChange: onChange, ...inputAttributes }));
    }
    return ((0, jsx_runtime_1.jsx)(validation_1.ValidationFeedback, { validatorOutput: validatorOutput, showValidation: showValidation, className: className, children: input }));
});
