"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dateTimeInputFormat = exports.militaryTimeFormat = exports.timeFormat = exports.dateInputFormat = void 0;
exports.getInvalidFeedback = getInvalidFeedback;
exports.getTimeZone = getTimeZone;
const moment_timezone_1 = __importDefault(require("moment-timezone"));
/** @internal */
function getInvalidFeedback(includesTime) {
    if (includesTime)
        return 'You must enter a valid date and time.';
    return 'You must enter a valid date (MM/DD/YYYY).';
}
/**
 * The moment format string used by [[`DateInput`]] and [[`DateInputNoPicker`]] when
 * `includesTime` is false.
 */
exports.dateInputFormat = 'M/D/YYYY';
/** @internal */
exports.timeFormat = 'h:mm a';
exports.militaryTimeFormat = 'HH:mm';
/**
 * The moment format string used by [[`DateInput`]] and [[`DateInputNoPicker`]] when
 * `includesTime` is true.
 */
exports.dateTimeInputFormat = `${exports.dateInputFormat} ${exports.timeFormat}`;
/** @internal */
function getTimeZone(timeZone) {
    return timeZone === 'local' ? moment_timezone_1.default.tz.guess() : timeZone;
}
